package com.example.krmth.quizapp;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import java.util.ArrayList;


 public class QuizDbHelper extends SQLiteOpenHelper {
    private static final String TAG = "DataBaseHelper";
    private static final String TABLE_NAME = "informations";
    private static final String DB_NAME = "quizDB";
    private static final String ID_ = "Id_";
    private static final String PAYS = "Pays";
    private static final String CAPITAL = "Capital";
    private static final String POPULATION = "Population";
    private static final String DEVISE = "Devise";
    // TODO: en cas d'echec changer les variable flag et monument en int pour recuperer les ref.
    private static final String MONUMENT = "Monumenent";
    private static final String CREATE_TABLE_QUIZ = "create table " + TABLE_NAME
            + "("
            + ID_ + " integer primary key autoincrement, "
            + PAYS + " text not null, "
            + CAPITAL + " text not null, "
            + POPULATION + " text not null ,"
            + DEVISE + " text not null, "
            + MONUMENT + " text);";


    private static final int DB_VERSION = 1;
    private String[] columns = {ID_, PAYS, CAPITAL, POPULATION, DEVISE, MONUMENT};

    private Context context;

    private ArrayList<Question> dat;

    QuizDbHelper(Context context) {
        super(context, DB_NAME, null, DB_VERSION);
        this.context = context;

    }


    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(CREATE_TABLE_QUIZ);

        Log.i(TAG, "onCreate: Invoked ");

    }


    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS '" + TABLE_NAME + "'");
        onCreate(db);

    }

    public void onDelete() {
        context.deleteDatabase(DB_NAME);
    }

    void insertInfo(Data data) {
        ContentValues contentValues = new ContentValues();
        //SQLiteDatabase db =this.getWritableDatabase();
        SQLiteDatabase db = this.getReadableDatabase();
        contentValues.put(columns[1], data.getPays().trim());
        contentValues.put(columns[2], data.getCapitale().trim());
        contentValues.put(columns[3], data.getPopulation().trim());
        contentValues.put(columns[4], data.getDevise().trim());
        contentValues.put(columns[5], data.getMonument().trim());

        db.insert(TABLE_NAME, null, contentValues);
        db.close();

    }

    ArrayList<Question> getAll() {
        SQLiteDatabase db = this.getReadableDatabase();
        String sql = "SELECT DISTINCT  * FROM " + TABLE_NAME;
        Cursor c = db.rawQuery(sql, null);
         dat = new ArrayList<Question>();
      //  Data data;

        if (c.moveToFirst()) {
            do {
                Question question = new Question();

                question.setQuestion("c'est quoi "+c.getString(c.getColumnIndex("pays")));
                question.setOption1(c.getString(c.getColumnIndex("capital")));
                question.setOption2(c.getString(c.getColumnIndex("capital")));
                question.setOption3(c.getString(c.getColumnIndex("capital")));
                dat.add(question);

                //cursor.moveToNext();
             /*   data = new Data();
                data.setQuestion(cursor.getInt(0));
                data.setPays(cursor.getString(1).trim());
                data.setCapitale(cursor.getString(2).trim());
                data.setPopulation(cursor.getString(3).trim());
                data.setDevise(cursor.getString(4).trim());
                data.setMonument(cursor.getString(5).trim());
                dat.add(data);*/
               /* data = new Data();
                data.setId(cursor.getInt(0));
                data.setPays(cursor.getString(1).trim());
                data.setCapitale(cursor.getString(2).trim());
                data.setPopulation(cursor.getString(3).trim());
                data.setDevise(cursor.getString(4).trim());
                data.setMonument(cursor.getString(5).trim());
                dat.add(data);*/
            } while (c.moveToNext());
        }

        c.close();
        db.close();
        return dat;
    }
}
